/************************************************* 
 * g@eXgvO
 * @FreqAnalizer03
 * @DDS AD9834̐go̓eXg
 *************************************************/
#include <xc.h>
/* RtBM[V̐ݒ */
// CONFIG1
#pragma config FOSC = INTOSC    // Oscillator Selection (INTOSC oscillator: I/O function on CLKIN pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = ON       // MCLR Pin Function Select (MCLR/VPP pin function is MCLR)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Memory Code Protection (Data memory code protection is disabled)
#pragma config BOREN = ON       // Brown-out Reset Enable (Brown-out Reset enabled)
#pragma config CLKOUTEN = ON    // Clock Out Enable (CLKOUT function is enabled on the CLKOUT pin)
#pragma config IESO = OFF       // Internal/External Switchover (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is disabled)

// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config VCAPEN = OFF     // Voltage Regulator Capacitor Enable bit (Vcap functionality is disabled on RA6.)
#pragma config PLLEN = ON       // PLL Enable (4x PLL enabled)
#pragma config STVREN = OFF     // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will not cause a Reset)
#pragma config BORV = LO        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), low trip point selected.)
#pragma config LPBOR = OFF      // Low Power Brown-Out Reset Enable Bit (Low power brown-out is disabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)

/* O[oϐA萔` */
#define  _XTAL_FREQ  32000000
unsigned char rcv;
unsigned long Freq;
/* ֐vg^CsO */
void Send(unsigned char Data);
unsigned char Receive(void);
void SetupDDS( unsigned long freqdata);
void SerialOut(unsigned long data);
/****** CvO *****/
int main(void) {
    /* NbNgݒ */
    OSCCONbits.IRCF = 14;           // 8MHz X PLL = 32MHz
    /* o̓s[hݒ */
    LATB = 0xFF;
    TRISA = 0x00;                   // PORTA@ׂďo
    TRISB = 0x01;                   // RB0̂݃AiO
    TRISC = 0x83;                   // RX SW0,1̂ݓ
    ANSELA = 0;                     // ׂăfW^
    ANSELB = 0x01;                  // RB0̂݃AiO
    ANSELC = 0;                     // ׂăfW^
    /* BTW[̃Zbg */
    LATCbits.LATC5 = 0;
    __delay_ms(100);                // 100msec
    LATCbits.LATC5 = 1;
    /* USART̏ݒ */
    TXSTA = 0x20;                   // TXSTA,M[hݒ
    RCSTA = 0x90;                   // RCSTA,M[hݒ
    BAUDCON=0x08;                   // BAUDCON@16bit
    SPBRG = 16;                     // SPBRG,ʐMxݒ(115.2kbps)
    /************ C[v  ********************/
    while (1) {
        Freq = 0;                                       // gZbg
        do{                                             // gݒl
            rcv = Receive();                            // 1 
            if((rcv >= '0')&&(rcv <= '9'))              // ̏ꍇ̂
                Freq = Freq * 10 + (int)(rcv - 0x30);   // glɕϊ
        }while (rcv != '#');                            // #܂ŌJԂ
        SetupDDS(Freq);                                 // DDSɎgݒo
    }
}
/********************************
 *  Setup DDS AD9834
 *  NbN 2^26@ݒ  2^28
 **********************************/
void SetupDDS( unsigned long freqdata){
    unsigned long temp;
    unsigned int uptemp, lowtemp;
    
    /* 1/4HzPʂȂ̂Ŏgx4ݒl  */
    /* 14rbg2P^ɂďo    */
    temp = 4 * freqdata;                            // 1/4HzP
    lowtemp = (unsigned int)(temp & 0x3FFF);        // 14rbg
    uptemp = (unsigned int)((temp >> 14) & 0x3FFF); // 14rbg
    /* go̓R}h=0x2028  OpĝƂ= 0x200A */
    SerialOut(0x2028);                              // R}h
    SerialOut(lowtemp + 0x4000);                    // 14rbgo
    SerialOut(uptemp + 0x4000);                     // 14rbgo
}
/*********************************
 *  DDS@AD9834M֐
 * @16rbgVAőM
 *********************************/
void SerialOut(unsigned long data){
    unsigned int i;                     // rbgJE^
    unsigned long mask;                 // rbg}XN
    
    mask = 0x8000;                      // rbg}XNZbg
    LATBbits.LATB3 = 0;                 // FSYNC Low Jn
    for(i=0; i<16; i++){                // 16rbgJԂ
        if(data & mask)                 // f[^rbgo
            LATBbits.LATB5 = 1;         // SDAT1̏ꍇ
        else
            LATBbits.LATB5 = 0;         // SDAT0̏ꍇ
        LATBbits.LATB4 = 0;             // SCK Low
        LATBbits.LATB4 = 1;             // SCK High@NbNo
        mask = mask >> 1;               // rbg}XNVtg
    }
    LATBbits.LATB3 = 1;                 // FSYNC HighI
}
/********************************
 * USART MsTu֐
 ********************************/
void Send(unsigned char Data) {
    while (!TXSTAbits.TRMT);            // MfB[҂
    TXREG = Data;                       // Ms
}
/********************************
 * USARTMTu֐
 ********************************/
unsigned char Receive(void){
    while(PIR1bits.RCIF == 0);              // Miv҂
    if((RCSTAbits.OERR)||(RCSTAbits.FERR)){ // G[ꍇ
       RCSTA = 0;                           // USARTAG[tONA
       RCSTA = 0x90;                        // USARTėL
       return(0xFF);                        // G[tOԂ
    }
    else                                    // M̏ꍇ
      return(RCREG);                        // Mf[^Ԃ
}
