/********************************************************************
*  ^ubgɂg
*  PIC16F1788 gpABluetoothŒʐM
*  góFAD9834@SPIڑ 67.108863MHz 1/4HzPʂŐݒ\
*  OAvFAD8310@AN12ŃAiO
********************************************************************/
#include <htc.h>
/* RtBM[V̐ݒ */
// CONFIG1
#pragma config FOSC = INTOSC    // Oscillator Selection (INTOSC oscillator: I/O function on CLKIN pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = ON       // MCLR Pin Function Select (MCLR/VPP pin function is MCLR)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Memory Code Protection (Data memory code protection is disabled)
#pragma config BOREN = ON       // Brown-out Reset Enable (Brown-out Reset enabled)
#pragma config CLKOUTEN = ON    // Clock Out Enable (CLKOUT function is enabled on the CLKOUT pin)
#pragma config IESO = OFF       // Internal/External Switchover (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is disabled)
// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config VCAPEN = OFF     // Voltage Regulator Capacitor Enable bit (Vcap functionality is disabled on RA6.)
#pragma config PLLEN = ON       // PLL Enable (4x PLL enabled)
#pragma config STVREN = OFF     // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will not cause a Reset)
#pragma config BORV = LO        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), low trip point selected.)
#pragma config LPBOR = OFF      // Low Power Brown-Out Reset Enable Bit (Low power brown-out is disabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)
/***** DDSpsw ******/
#define ddsFSYN     LATBbits.LATB3
#define ddsSCLK     LATBbits.LATB4
#define ddsSDAT     LATBbits.LATB5
#define RedLED      LATAbits.LATA0
#define GreenLED    LATAbits.LATA1
/**** ϐ`@***/
#define  _XTAL_FREQ  32000000
union{
    unsigned long Freq;                     // DDSpg
    unsigned char cFreq[4];                 // oCg
}ddsFreq;
unsigned long oldFreq, temp;
unsigned char State, Flag;
unsigned char RcvBuf[64];                   // BluetoothMobt@
unsigned char SndBuf[64];                   // BluetoothMobt@
int Index, i, j;
/** ֐vg^CsO */
void Process(void);
void Send(unsigned char data);
void SendStr(unsigned char * str);
void SetupDDS( unsigned long freqdata);
void SerialOut(unsigned long data);
unsigned int GetADC(unsigned char ch);

/************ C֐ ********************/
void main(void){
    /* NbNgݒ */
    OSCCONbits.IRCF = 14;               // 8MHz X PLL = 32MHz
    /* o̓s[hݒ */
    LATB = 0xFF;                        // FSYNC,SCLK High
    TRISA = 0x00;                       // PORTA@ׂďo
    TRISB = 0x01;                       // RB0̂݃AiO
    TRISC = 0x83;                       // RX SW0,1̂ݓ
    ANSELA = 0;                         // ׂăfW^
    ANSELB = 0x01;                      // RB0̂݃AiO
    ANSELC = 0;                         // ׂăfW^
    /* BTW[̃Zbg */
    LATCbits.LATC5 = 0;
    __delay_ms(100);                    // 100msec
    LATCbits.LATC5 = 1;
    /* USART̏ݒ */
    TXSTA = 0x24;                       // TXSTA,M[hݒ BRGH=1
    RCSTA = 0x90;                       // RCSTA,M[hݒ
    BAUDCON=0x08;                       // BAUDCON@16bit
    SPBRGH = 0;
    SPBRGL = 68;                        // SPBRG,ʐMxݒ(115.2kbps)
    PIR1bits.RCIF = 0;                  // 荞݃tONA
    PIE1bits.RCIE = 1;                  // 荞݋
    /* dݒ */
    FVRCON = 0x83;                      // ADpREF=4.096V
    /* ADC̏ݒ */
    ADCON0 = 0;                         // ADC
    ADCON1 = 0x63;                      // A1/64NbNAFVR
    ADCON2 = 0x0F;                      // gKȂAVREF-
    ADCON0bits.ADON = 1;                // ADL
    /* DDS@AD9834̏ */
    ddsFreq.Freq = 1000;                // l1kHz
    oldFreq = 0;
    /* ϐ */
    Index = 0;
    Flag = 0;
    State = 1;
    /* 荞݋**/
    INTCONbits.PEIE = 1;
    INTCONbits.GIE = 1;

    /*********** C[v ***************/
    while(1)  {
       switch(State){
            case 1:
                __delay_ms(1000);                   // ڑ҂x
                Index = 0;                          // obt@CfbNX
                State = 2;
                break;
            case 2:
                /* MR}h[v */
                if((Flag == 1) && (RcvBuf[0] == 'S')) {
                    RedLED ^= 1;                    // ڈLED]
                    SndBuf[0] = 'M';                // ԐM}[Nۑ
                    SndBuf[1] = RcvBuf[1];          // ԐMʕۑ
                    Process();                      // R}hs
                    Index = 0;                      // obt@|C^
                    Flag = 0;                       // MtONA
                }
                break;
            default:
                break;
        }
    }
}

/**************************************************
*  f[^M֐
*  f[^RcvBuf[] 
***************************************************/
void Process(void){ 
    /******** MR}hƂ̏ ********/
    switch(RcvBuf[1]){                              // R}hR[h`FbN
        /** f[^vJngK ***/
        case 'T':
            SndBuf[2] = 'O';                        // OKM
            SndBuf[3] = 'K';
            SndBuf[4] = 'E';
            SendStr(SndBuf);
            break;
        /** gݒƃxlԑ */
        case 'N':
            /** gݒl擾Ɛݒ萧 **/
            for(i=0; i<4; i++)                      // 4oCgJԂ
                ddsFreq.cFreq[i] = RcvBuf[i+2];     // oCg琔l֕ϊ
            if(ddsFreq.Freq != oldFreq)             // OƓgȂ牽Ȃ
                SetupDDS(ddsFreq.Freq);             // قȂgȂݒo͎s
            oldFreq = ddsFreq.Freq;                 // gf[^XV
            /* vl艻҂@**/
            __delay_ms(50);                         // 푪葕ȕo͈҂
            /* xvxf[^ԑ */
            temp = 0;                               // vlZbg
            if(ddsFreq.Freq < 200){                 // 200Hzȉ̏ꍇ
                for(i=0; i<250; i++){               // 250TvO
                    temp = temp + GetADC(12);       // CH12肵ϗp̉Z
                    __delay_ms(1);                  // 1msec
                }
                temp /= 250;                        // 250̕ς߂
            }
            else{                                   // 200Hzȏ̏ꍇ       
                for(i=0; i<40; i++){                // 40̕               
                    temp = temp + GetADC(12);       // CH12肵ϗp̉Z
                    __delay_ms(1);                  // 1msecԊuŃTvO
                }
                temp /= 40;                         // 40̕ς߂
            }
            SndBuf[2] = temp % 256;                 // xlʂ𑗐Mobt@ɃZbg
            SndBuf[3] = temp / 256;                 // xlʂ𑗐Mobt@ɃZbg
            SndBuf[4] = 'E';                        // I}[N
            SendStr(SndBuf);                        // BluetoothMs
            break;
        /*** ̑ ****/
        default:
            break;
    }     
}
/*************************************
* 荞ݏ֐
* @USARTM荞
*************************************/
void interrupt isr(void){
    unsigned char data;

    if(PIR1bits.RCIF){                              // M荞݂H
        PIR1bits.RCIF = 0;                          // M荞݃tONA
        if((RCSTAbits.OERR) || (RCSTAbits.FERR)){   // G[ꍇ
            RCSTA = 0;                              // USART
            RCSTA = 0x90;                           // USARTėL
        }
        else{                                       // M̏ꍇ
            if((State > 1)&&(Index<64)){            // M̏ꍇ
                RcvBuf[Index++] = RCREG;            // f[^o
                if(Index >= 64)                     // 64oCgMH
                    Flag = 1;                       // MtOI
            }
            else                                    // R}hsŖꍇ
                data = RCREG;                       // ǂݔ΂Ė
        }
    }
}
/*******************************
 * w`lA/DϊTu֐
 *@12rbgf[^Ŗ߂
 *******************************/
unsigned int GetADC(unsigned char ch){
    unsigned int i, temp;
    
    ADCON0bits.CHS = ch;                    // `lw
    __delay_us(10);                         // ANCWV^C҂
    ADCON0bits.ADGO = 1;                    // ADϊJn
    while(ADCON0bits.ADGO == 1);            // ϊI҂
    temp = ADRESH * 256 + (ADRESL & 0xF0);  // 12rbgl
    temp /= 16;                             // E4rbgVtg
    return(temp);                           // ϊf[^߂
}
/********************************
 * USART MsTu֐
 ********************************/
void Send(unsigned char data){
    while(!TXSTAbits.TRMT);             // MfB[҂
    TXREG = data;                       // Ms
}
/********************************
 * Bluetooth񑗐M֐
 *******************************/
void SendStr(unsigned char * str){
    GreenLED ^= 1;
    for(i= 0; i<64; i++)                // 64oCgM
        Send(*str++);                   // Ms
}
/********************************
 *  Setup DDS AD9834
 *  NbN 2^26@ݒ  2^28
 **********************************/
void SetupDDS( unsigned long freqdata){
    unsigned long temp;
    unsigned int uptemp, lowtemp;
    
    /* 1/4HzPʂȂ̂Ŏgx4ݒl  */
    /* 14rbg2P^ɂďo    */
    temp = 4 * freqdata;                            // 1/4HzP
    lowtemp = (unsigned int)(temp & 0x3FFF);        // 14rbg
    uptemp = (unsigned int)((temp >> 14) & 0x3FFF); // 14rbg
    /* go̓R}h=0x2028  OpĝƂ= 0x200A */
    SerialOut(0x2028);                              // R}h
    SerialOut(lowtemp + 0x4000);                    // 14rbgo
    SerialOut(uptemp + 0x4000);                     // 14rbgo
}
/*********************************
 *  DDS@AD9834M֐
 * @16rbgVAőM
 *********************************/
void SerialOut(unsigned long data){
    unsigned int i;                     // rbgJE^
    unsigned long mask;                 // rbg}XN
    
    mask = 0x8000;                      // rbg}XNZbg
    LATBbits.LATB3 = 0;                 // FSYNC Low Jn
    for(i=0; i<16; i++){                // 16rbgJԂ
        if(data & mask)                 // f[^rbgo
            LATBbits.LATB5 = 1;         // SDAT1̏ꍇ
        else
            LATBbits.LATB5 = 0;         // SDAT0̏ꍇ
        LATBbits.LATB4 = 0;             // SCK Low
        LATBbits.LATB4 = 1;             // SCK High@NbNo
        mask = mask >> 1;               // rbg}XNVtg
    }
    LATBbits.LATB3 = 1;                 // FSYNC HighI
}
